/* hello.c 
 * Copyright (C) 1998 by Ori Pomerantz
 * 
 * "Hello, world" - the kernel module version. 
 */

/* The necessary header files */

/* Standard in kernel modules */
#include <linux/kernel.h>   /* We're doing kernel work */
#include <linux/module.h>   /* Specifically, a module */

#include "/flame3/include/module.h"
#include "flamecyc.h"

static int  pmodule_slot = -1;
static char * pmodule_myname = "blank";

extern void set_expire_timer();
extern int Cyc_process_pkt();
extern char * Cyc_ioctl_query(char *);
extern char * query_return();

/* Initialize the module */
int init_module()
{
    int i;
    printk( "Trying to load module...\n");
    i = pmodules_add(Cyc_process_pkt);
    if(i < 0) {
        //error
        printk("Error occurred trying to load module.  Did not get 
a valid module index!\n");
        return -1;
    } else {
        pmodule_slot = i;
    }
    pmodules_query[i]      = Cyc_ioctl_query;
    pmodules_query_return[i] = query_return;
    pmodules_name[i]       = pmodule_myname;
    pmodules_set_expire[i] = set_expire_timer;
    cycles_allowed[i]      = 750;

    /* If we return a non zero value, it means that 
     * init_module failed and the kernel module 
     * can't be loaded */
    return 0;
}


/* Cleanup - undid whatever init_module did */
void cleanup_module()
{
    printk("Unloading module for flamedev..\n");
    if(pmodule_slot >= 0)
        pmodules[pmodule_slot] = NULL;
}  
/*
void exit(int i)
{
	printk("Exiting............\n
	should longjmp back to scheduler\n");
}
*/
/*
int stdin=0;
int stderr=2;
int stdout=1;
*/
int stderr = 2;

int Cyc_stdout = 0;
char Cyc_Core_Invalid_argument[21]="\000\000\000\000Invalid_argument\000";
char Cyc_Core_Impossible[15] = "\000\000\000\000Impossible\000";

void bzero(char *m, int len)
{
	int i;
	for(i=0;i<len;i++)
		m[i] = 0;
}
void free(char *m)
{
	kfree(m);
}
void Cyc_Execinfo_bt()
{
	printk("Cyc_Execinfo_bt\n
	should longjmp back to the scheduler: doing backtrace.\n");
}
void Cyc_Core_Failure()
{
	printk("Cyc_Core_Failure\n
	should longjmp back to the scheduler: clean up module. \n");
}
/*
int strncmp(const char *s1, const char *s2, int len)
{
    unsigned register char c1 = '\0';
    unsigned register char c2 = '\0';
 
    while (len > 0) {
           c1 = (unsigned char) *s1++;
           c2 = (unsigned char) *s2++;
           if (c1 == '\0' || c1 != c2)
               return c1 - c2;
           len--;
    }
    
    return c1 - c2;
}
int strlen(const char *str)
{
    register char *ptr = (char *) str;
	     
    while (*ptr)
       ptr++;
   return (ptr - str);
}
*/
int fprintf(void * fp, const char *fmt, ...)
{
//	printk("fprintf\n");
/*       va_list ptr;
       int rv;
	 
       va_strt(ptr, fmt);
       rv = vfnprintf(fmt, ptr);
       va_end(ptr);
       return rv;
*/
}
/*
int Cyc_printf(const char *fmt, ...)
{
	va_list args;
	static char buf[1024];
        va_start(args, fmt);
	vsprintf(buf, fmt, args);
        va_end(args);
	printk("%s", buf);
}
*/

void Cyc_putc(char *c)
{
	printk("%c", c);
}
void *realloc(char*m, int size)
{
	int i;
	char *n;

	printk("*********************realloc %x, newsize = %d\n", m, size);

	n = kmalloc(size,0);
	for(i=0;i<size;i++)
		n[i] = m[i];

	kfree(m);
	return n;
}
void *calloc(int m, int size)
{
	int i = m * size;
	char *b;

//	printk("calloc %d\n", m*size);
 	b= kmalloc(i,0);
	if(!b) {printk("can not allocate enough space\n"); return 0;}
	for(;i>0;i--)
		b[i]=0;
	return b;
}
