#include "common.h"


#include <fcntl.h>      /* open */ 
#include <unistd.h>     /* exit */
#include <sys/ioctl.h>  /* ioctl */
#include <string.h>

/* Main - Call the ioctl functions */
int
main(int argc, char **argv)
{
    struct flamedev_io a;
    int error, fd;

        if(argc != 2) {
        printf ("\nUsage: %s <module_name>\n\n",argv[0]);
        exit(-1);
    }
        
  fd = open("/dev/flamedev", O_RDWR);
  if (fd < 0) {
      printf ("Can't open device file!\n");
    exit(-1);
  }
  if(DEBUG)    printf("dev_test: querying module... \n");

    bzero(a.request, MAXMSGLEN);
    bzero(a.response, MAXMSGLEN);
    //strlcpy(a.request, "dev_test: request\n", sizeof(a.request));
    strncpy(a.request, argv[1], sizeof(a.request));
    a.mod_id=99;
    error = ioctl(fd, MODQUERY, &a);
    if (error == -1)
        err(1, "ioctl");
    
    if(DEBUG)    printf("MODQUERY: mod_id=%d response = %s\n", a.mod_id, 
                        a.response);
    
    printf("%s\n",a.response);
    
  close(fd); 
  return 0;
  
}
