#ifndef __INCLUDED_CHECKPOINT
#define __INCLUDED_CHECKPOINT

#include "setjmp.h"

static inline unsigned long get_esp(void)
{
	unsigned long esp;
       __asm__("movl %%esp,%0; ":"=r" (esp));
       return esp;
}

#define MAX_OUTPUT  1024
static inline unsigned long long 
rdtsc(void)
{
        unsigned long long rv;
        __asm __volatile(".byte 0x0f, 0x31" : "=A" (rv));
        return (rv);
}
static unsigned long long  __expire_timer;
static unsigned long stack_low_limit;

extern jmp_buf jsched;

char __OUTPUT__[MAX_OUTPUT];
int curindex;
static inline void checkpoint()
{
	if(__expire_timer< rdtsc())
		longjmp(jsched, 1);
}

static inline void check_call()
{
	if(get_esp() < stack_low_limit)
		longjmp(jsched, 1);
	checkpoint();
}
/*
void set_expire_timer(unsigned long long tim )
{
	__expire_timer = tim;
}*/
void set_expire_timer(unsigned long stklow, unsigned long long tim )
{
        stack_low_limit = stklow;
        __expire_timer = tim;
}
void output_byte(char c)
{
	if(curindex>=MAX_OUTPUT)
		return;
	__OUTPUT__[curindex++] = c;
}

char *query_return()
{
	curindex = 0;
	return __OUTPUT__;
}

#endif
