/* This is the skeleton of the scheduler module. 
 * It provides the fuctions for handling errors that 
 * arise inside USER provided module.
 * 1. The user may use "exit" to exit their module.
 *    This should be treated as the user's request being 
 *    completed. Scheduler should reclaim all the 
 *    resources used by this module.
 * 2. Errors that are raised by Cyclone.
 *    The function Cyclone_Core_Failure will be called.
 *    We need to clean up the user module in this function.
 */
/* Standard in kernel modules */

#include "setjmp.h"
#include "flamecyc.h"

void exit(int i)
{
	printk("Exiting............\n
	should longjmp back to scheduler\n");
}
/*
int stdin=0;
int stderr=2;
int stdout=1;
*/
int stderr = 2;

int Cyc_stdout = 0;
char Cyc_Core_Invalid_argument[21]="\000\000\000\000Invalid_argument\000";
char Cyc_Core_Impossible[15] = "\000\000\000\000Impossible\000";

void bzero(char *m, int len)
{
	int i;
	for(i=0;i<len;i++)
		m[i] = 0;
}
void free(char *m)
{
	ldkfree(m);
}
void Cyc_Execinfo_bt()
{
	printk("Cyc_Execinfo_bt\n
	should longjmp back to the scheduler: doing backtrace.\n");
}
void Cyc_Core_Failure()
{
	printk("Cyc_Core_Failure\n
	should longjmp back to the scheduler: clean up module. \n");
}

int strncmp(const char *s1, const char *s2, int len)
{
    unsigned register char c1 = '\0';
    unsigned register char c2 = '\0';
 
    while (len > 0) {
           c1 = (unsigned char) *s1++;
           c2 = (unsigned char) *s2++;
           if (c1 == '\0' || c1 != c2)
               return c1 - c2;
           len--;
    }
    
    return c1 - c2;
}
int strlen(const char *str)
{
    register char *ptr = (char *) str;
	     
    while (*ptr)
       ptr++;
   return (ptr - str);
}
int fprintf(void * fp, const char *fmt, ...)
{
//	printk("fprintf\n");
/*       va_list ptr;
       int rv;
	 
       va_strt(ptr, fmt);
       rv = vfnprintf(fmt, ptr);
       va_end(ptr);
       return rv;
*/
}
/*
int Cyc_printf(const char *fmt, ...)
{
	va_list args;
	static char buf[1024];
        va_start(args, fmt);
	vsprintf(buf, fmt, args);
        va_end(args);
	printk("%s", buf);
}
*/

void Cyc_putc(char *c)
{
	printk("%c", c);
}
void *realloc(char*m, int size)
{
/*
	int i;
	char *n;

	printk("*********************realloc %x, newsize = %d\n", m, size);

	n = kmalloc(size);
	for(i=0;i<size;i++)
		n[i] = m[i];

	kfree(m);
	return n;
*/
	return ldkrealloc(m, size);
}
void *calloc(int m, int size)
{
	int i = m * size;
	char *b;

//	printk("calloc %d\n", m*size);
 	b= ldkmalloc(i);
	if(!b) {printk("can not allocate enough space\n"); return 0;}
	for(;i>0;i--)
		b[i]=0;
	return b;
}
module_init(init_module);
module_exit(cleanup_module);
