#include <linux/kernel.h>   /* We're doing kernel work */
#include <linux/module.h>   /* Specifically, a module */

#include "../include/module.h"
#include "flamecyc.h"

static int  pmodule_slot = -1;
static char * pmodule_myname = "mtraj";

extern void set_expire_timer();
extern int Cyc_process_pkt();
extern char * Cyc_ioctl_query(char *);
extern char * query_return();
 MODULE_LICENSE("GPL");


/* Initialize the module */
int init_module()
{
    int i;
    printk( "Trying to load module [%s]...\n", pmodule_myname);
    i = pmodules_add(Cyc_process_pkt);
    if(i < 0) {
        //error
        printk("Error occurred trying to load module [%s].  Did not get 
a valid module index!\n",pmodule_myname);
        return -1;
    } else {
        pmodule_slot = i;
    }
    pmodules_query[i]      = Cyc_ioctl_query;
    pmodules_query_return[i] = query_return;
    pmodules_name[i]       = pmodule_myname;
    pmodules_set_expire[i] = set_expire_timer;
    cycles_allowed[i]      = 1000000;
    stackspace_allowed[i]  = 4096;
    
    /* If we return a non zero value, it means that 
     * init_module failed and the kernel module 
     * can't be loaded */
    return 0;
}


/* Cleanup - undid whatever init_module did */
void cleanup_module()
{
    printk("Unloading module [%s] for flamedev..\n",pmodule_myname);
    pmodules_delete(pmodule_slot);    
}
