#ifndef __INCLUDED_CHECKPOINT
#define __INCLUDED_CHECKPOINT

#include "setjmp.h"

#define MAX_OUTPUT  1024

static inline unsigned long get_esp(void)
{
	unsigned long esp;
       __asm__("movl %%esp,%0; ":"=r" (esp));
       return esp;
}

static inline unsigned long long 
rdtsc(void)
{
        unsigned long long rv;
        __asm __volatile(".byte 0x0f, 0x31" : "=A" (rv));
        return (rv);
}
static unsigned long long  __expire_timer;
static unsigned long stack_low_limit;

extern jmp_buf jsched;

static char __OUTPUT__[MAX_OUTPUT];
static int curindex=0;
static inline void checkpoint()
{
	if(__expire_timer< rdtsc())
		longjmp(jsched, 1);
}
static inline void check_call()
{
	if(get_esp() < stack_low_limit)
		longjmp(jsched, 1);
	checkpoint();
}

struct handler_cons{
	int runtimestack[2];
	jmp_buf handler;
};

extern struct handler_cons top_handler;
extern void _push_handler();

void set_expire_timer(unsigned long stklow, unsigned long long tim )
{
	__expire_timer = tim;
        stack_low_limit = stklow;
	memcpy(&top_handler.handler, &jsched, 24);
  	_push_handler(&top_handler);

}
static int initialized_OUTPUT = 0;

void output_byte(char c)
{
    if(!initialized_OUTPUT){
        volatile int i;

        initialized_OUTPUT=1;
        
        for(i=0;i<MAX_OUTPUT;i++)
            __OUTPUT__[i]=0;
    } 
    if(curindex>=MAX_OUTPUT)
		return;
	__OUTPUT__[curindex++] = c;
}

char *query_return()
{
	curindex = 0;
        initialized_OUTPUT = 0;
	return __OUTPUT__;
}

#endif
