/* chardev.h - the header file with the ioctl definitions.
 *
 * The declarations here have to be in a header file, 
 * because they need to be known both to the kernel 
 * module (in chardev.c) and the process calling ioctl 
 * (ioctl.c)
 */

#ifndef COMMON_H
#define COMMON_H

#include <linux/ioctl.h> 
#define MAJOR_NUM 100

#define NUM_THREADS 2
#define MAXMSGLEN 1024
#define DEBUG 1
#define TDEBUG 0

struct flamedev_io {
    int mod_id;
    char request[MAXMSGLEN];
    char response[MAXMSGLEN];
    int errno;
};

#define MODQUERY  _IOWR(MAJOR_NUM, 0, struct flamedev_io)

/* The name of the device file */
#define DEVICE_FILE_NAME "/dev/flamedev"


#endif
