#include <linux/kernel.h>

#define __NO_VERSION__

// only export symbols via EXPORT_SYMBOL()
#define EXPORT_SYMTAB

#include "linux/module.h"

#include <linux/version.h>
#include <linux/skbuff.h>

#include <linux/fs.h>
#include <linux/string.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/smp_lock.h>
#include <linux/sched.h>
#include <linux/module.h>
#include <asm/signal.h>
#include <asm/unistd.h>
#include <asm/semaphore.h>
#include "include/module.h"
#include "linux/netdevice.h"
#include "linux/wait.h"
#include "include/common.h"
//#include "include/flame_hook.h"
#include "include/modstat.h" //for linux 2.4 module_exception stuff

#ifndef KERNEL_VERSION
#define KERNEL_VERSION(a,b,c) ((a)*65536+(b)*256+(c))
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,2,0)
#include <asm/uaccess.h>  /* for get_user and put_user */
#endif

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,4,0)
typedef struct net_device ndevice;
#else
typedef struct device ndevice;
#endif

static unsigned int CURRENT_MAX = 0;

void set_curmax(unsigned int index)
{
    if(index+1 > CURRENT_MAX)
        CURRENT_MAX = index + 1;    
}

void del_curmax(unsigned int index)
{
    unsigned int i,max=0;
    if(index+1 > CURRENT_MAX) {
        for(i=0;i<MAX_PMODULES;i++)
        {    
            if(pmodules[i]) max=i;
        }
        CURRENT_MAX = max;
    }    
}
static int meowmix =0;

// our thread
flame_threads my_thread;
extern char *devname;

/* our exported kernel variables to be used with modules */
jmp_buf      jsched;
int    (*pmodules[MAX_PMODULES])(struct sk_buff *);
char    *     pmodules_name[MAX_PMODULES];
char    *     (*pmodules_query[MAX_PMODULES])(char *);
char    *     (*pmodules_query_return[MAX_PMODULES])(void);
void          (*pmodules_set_expire[MAX_PMODULES])(unsigned long,unsigned long long);
unsigned long long cycles_allowed[MAX_PMODULES];
unsigned long stackspace_allowed[MAX_PMODULES];
struct ioctlquery_buf pmodules_querybuf[MAX_PMODULES];
extern ndevice *polling_dev;
extern struct module kernel_module;
/*struct module *module_list = &kernel_module;*/
extern struct module *module_list;


static inline unsigned long get_esp(void)
{
        unsigned long esp;
       __asm__("movl %%esp,%0; ":"=r" (esp));
       return esp;
}

/* delete module from index pmodule_slot */
int pmodules_delete(int pmodule_slot) {

    if(pmodule_slot >= 0) {
        pmodules[pmodule_slot]              = 0;
        pmodules_query[pmodule_slot]        = 0;
        pmodules_query_return[pmodule_slot] = 0;
        pmodules_name[pmodule_slot]         = 0;
        pmodules_set_expire[pmodule_slot]   = 0;
        cycles_allowed[pmodule_slot]        = 0;
        del_curmax(pmodule_slot);
    }
#if DEBUG
    printk("Deleted module at index %d\n",pmodule_slot);
#endif
    return 0;
}


/* wrapper function that we call to longjmp back to the scheduler */
/* used by module_exception() below */
void jsched_wrapper()
{
    longjmp(jsched,1);
}

/* called by linux fault handler, if the exception is caused by us, we
   purge the offending module and continue */

// The linux 2.4 version!
// we no longer have module_list to walk, so just check the modules
// we have listed as dependencies -- notably our pmodules
void *module_exception(unsigned long faultaddr) 
{
    int i;
    char name[128];
    struct module *mod;
    struct module_ref *ref;
    unsigned long modaddr;
    
    printk("flame_module_exception %x ",(unsigned int)faultaddr);    

    // going over all the pmodules is a waste, but we need the index
    // of the module, so this is a quick hack
    for(i=0;i<MAX_PMODULES;i++) {
        if(pmodules_name[i] != NULL && pmodules[i] != NULL) {
            memset(name, '\0',128);
            strcpy(name,"flame_");
            strcat(name,pmodules_name[i]);
            printk("\nTrying [%s], index %d\n",name,i);

            // our flame dependencies -- our pmodules
            ref = __this_module.refs;

            for(mod=ref->ref ; mod ; ref=ref->next_ref, mod=ref->ref)
                {
                    modaddr = (unsigned long) mod;
                    
                    if(mod->flags & MOD_DELETED)
                        continue;
                    if( (modaddr <= faultaddr) && (modaddr + mod->size >= faultaddr) )
                        {
                            printk("Fault on %s, deleting from index %d\n",name,i);
                            // delete module here
                            lock_kernel();
                            pmodules_delete(i);
                            unlock_kernel();
                            
                            return jsched_wrapper;
                            break;
                        }        
                } // over all refs
        }
    } // over all pmodules
        
    return 0; // not our fault, crash!    
}

struct ioctlquery_buf * alloc_querybuf(void) 
{
    struct ioctlquery_buf *b;
    b = kmalloc(sizeof(struct ioctlquery_buf), GFP_ATOMIC);
    return b;
}

static inline unsigned long long 
myrdtsc(void)
{
        unsigned long long rv;
        __asm __volatile(".byte 0x0f, 0x31" : "=A" (rv));
        return (rv);
}

int pmodules_add(int (*v)(struct sk_buff *)) {
    int i;
    for(i=0;i<MAX_PMODULES;i++) {
        if (pmodules[i] == NULL) {
            pmodules[i] = v;
//            printk("module_add: adding at index %d 0x%lx\n",i,pmodules[i]);
            printk("module_add: adding at index %d %p\n",i,pmodules[i]);
            // set the current maximum index in the scheduler
            set_curmax(i);
            return i;
        }
    }
    // on error
    return -1;
}

/* *************************************************** */

int z=0;
static int jmpset =0;

int
frey_hookmod(struct sk_buff *skb) {
    volatile int i=0,j=0,jret=0;
    int retval=0;
    char *ppkt;
    static int loop=0;
    static int numpackets =0;
    static int totalpackets = 0;
//    static unsigned long long waste = 190;
    volatile unsigned long long start=0,end=0;
//    unsigned int burst=16;
    
    i=0;j=0;z=0;
    if(0)    printk(" [%d] ",meowmix++);


    if(skb == NULL) {
        printk("frey_hookmod: NULL skb\n");
        return 0;
    }
    
// check that its the right device
    if(skb->dev)
        if(skb->dev->name) {
            if(!strcmp(skb->dev->name,devname))
                totalpackets++;
            else
                return 0;
        }
// printk("ifname = %s\n",skb->dev->name);
 loop = 0;
 //numpackets = 0;
 
 z=0; 
 
 jret = setjmp(jsched);
 if (!jmpset) {
     jmpset=1;
     printk("jump set\n");
 }
 
 if(jret==1) {
     if(DEBUG)printk("return from jmp %d\n",z);
 }
 numpackets++;
 /*
   //waste cycles here            
   limit = myrdtsc() + waste;
   while(myrdtsc() < limit) {
   foo = 13;
   }
 */
// while(pmodules[z++] != NULL) {
 for(;z<CURRENT_MAX;z++) {
     if(pmodules[z] == NULL) {
         continue;
     }
     j=z-1;
     if(pmodules_set_expire[z] != NULL && cycles_allowed[z] > 0) {
         unsigned long esp = get_esp();
         pmodules_set_expire[z]( esp - stackspace_allowed[z],(start=myrdtsc()) + cycles_allowed[z]);
#if DEBUG
         printk("slot%d alotted %Lu cycles.\n",z, cycles_allowed[z]);
#endif
     }
     
     //ppkt = (char *)myskb->mac.ethernet;
     if(skb == NULL || skb->data == NULL) {
         printk("Cannot process packet, skb=NULL\n");
         continue;
     }
     start=myrdtsc();
     ppkt = (char *)skb->data-14;
     retval = calluser(ppkt, pmodules[z]);
     end = myrdtsc();
#if DEBUG
     printk("Elapsed: [%Lu] cycles.\n", end-start);
     printk("slot %d: return=[%d]\n", z, retval);
#endif
 }
 
//             if(myskb && polling) kfree_skb(myskb);
 //if(skb) kfree_skb(skb);
 return(0);
}


/* Export these symbols to our kernel */
EXPORT_SYMBOL_NOVERS(pmodules);
EXPORT_SYMBOL_NOVERS(pmodules_add);
EXPORT_SYMBOL_NOVERS(pmodules_delete);
EXPORT_SYMBOL_NOVERS(jsched);
EXPORT_SYMBOL_NOVERS(pmodules_name);
EXPORT_SYMBOL_NOVERS(pmodules_query);
EXPORT_SYMBOL_NOVERS(pmodules_query_return);
EXPORT_SYMBOL_NOVERS(pmodules_set_expire);
EXPORT_SYMBOL_NOVERS(cycles_allowed);
EXPORT_SYMBOL_NOVERS(stackspace_allowed);



/* end of file */
